'' =================================================================================================
''
''   File....... acc_test1.spin
''   Purpose.... test Background timer with accelerometer
''   Author..... Jim Meek "RS_Jim"
''               -- see below for terms of use
''   E-mail..... jmeek1@q.com
''   Started.... 1 Mar 2011
''   Updated.... 
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28
  hb  = 16               'heartbeat pin
  lobState = 0             'active lo
  hibstate = 1             'active hi 
  button = 3
  XOUT  = 7
  YOUT  = 6
  
con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS
   #0, ET_MS, ET_SC, ET_MN, ET_HR, ET_DY, ET_WK,ET_MO  
   #0, LT_MS, LT_SC, LT_MN, LT_HR, LT_DY, LT_WK,LT_MO
obj

  et   : "jm_etimer_v2_par"
  term : "fullduplexserial"
  acc   : "Memsic2125_v1.2"
  memsic : "Memsic_timer1"

var

  long  mytimer[10]                                              ' timer registers
  long  tlapse[10]

  long  stack[32]                                               ' for Spin cog
  

pub main | temp

  et.init(@mytimer, hb)                                         ' 1Hz heartbeat on P16
  memsic.init(@mytimer,@tlapse,xout,yout)
  cognew(dasblinker(23), @stack)                                ' launch Spin cog
  
  term.start(RX1, TX1, %0000, 115_200)                          ' start serial 
  waitcnt((clkfreq / 1_000)*2_000 + cnt)

  term.tx(CLS)
  term.str(string("Accelerometer Test V1"))
  waitcnt(clkfreq / 80_000 + cnt)
    term.tx(GOTOXY)
    term.tx(5)
    term.tx(2)
    term.str(string("Accelerometer rawx "))
    dec3(tlapse[LT_MN])
    term.str(string(" Acc Rawy  "))
    dec3(tlapse[LT_HR])
    term.str(string(" #rawx "))
    dec2(tlapse[LT_DY])
    term.str(string(" #rawy "))
    dec2(tlapse[LT_WK])
    term.str(string(" newacc "))
    dec2(tlapse[LT_MO])
   
    
  repeat
    term.tx(GOTOXY)
    term.tx(0)
    term.tx(4)

    dec2(mytimer[3])
    term.tx(":")
    dec2(mytimer[2])
    term.tx(":")
    dec2(mytimer[1])
    term.tx(".")
    dec3(mytimer[0])
    term.tx(CLREOL)
    term.tx(CR)
    term.str(string(" Memsic Time lapsed "))
    dec3(tlapse[LT_MS] )
    term.str(string("  ACC newacc "))
    dec3(tlapse[LT_SC])
    term.str(string( " stateflags "))
    dec3(tlapse[LT_WK])  
    {term.str(string("Accelerameter rawx "))
    
    dec3(ACC.Mx)
    term.str(string(" Acc Rawy  "))
    
    dec3(ACC.MY)
    term.str(string(" Milliseconds."))}
    term.tx(CLREOL)
    waitcnt(clkfreq / 500 + cnt) 


pub dec2(n)

  if (n < 10)
    term.tx("0")
    
  term.dec(n)


pub dec3(n)

  if (n < 10)
    term.tx("0")

  if (n < 100)
    term.tx("0")
    
  term.dec(n)
  

pri dasblinker(pin) | s                                         ' launch with cognew

'' pin will be high when 1s digit of seconds reg is 5

  dira[pin] := 1
  outa[pin] := 0

  repeat
    s := mytimer[et#ET_SC] // 10                                ' isolatie 1s digit
    outa[pin] := (s == 5)                                       ' on when digit is 5

'    if (mytimer[et#ET_MN] == 1)                                 ' one minute elapsed?
 '     et.reset                                                  ' yes, reset timer